/**************************************************************************
 Copyright (c) 2007-2008, Intel Corporation. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  3. Neither the name of the Intel Corporation nor the names of its
     contributors may be used to endorse or promote products derived from
     this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.

***************************************************************************/
#ifndef _DND_AGENT_H_
#define _DND_AGENT_H_

#include "L5Common.h"
#include "L5OpCodes.h"		

#include "Act.h"

typedef void (*pDnDOutputCB_t)();
typedef APPSRV_INIT_ST (*pDnDOutputInitCB_t)();

void DnDAgent_Shutdown();

void DnDAgent_InitLogic();
//APPSRV_INIT_ST DnDAgent_Initialize();
EXTERN_C EXPORT APPSRV_INIT_ST DnDAgent_Initialize(tL5DispatcherFunctions *L5disp, tUtilityFunctions *UtilFn);
EXTERN_C EXPORT BOOL DnDAgent_Start();
EXTERN_C EXPORT BOOL DnDAgent_Stop();
EXTERN_C EXPORT void DnDAgent_Finalize();

void DnDAgent_MessagesHandler(	L5_CONNECTION Conn,
								L5_TARGET_ID nOriginID,

								UINT32 dwSentMessageID,
								void  *pvSentBuffer,
								UINT32 cbSentBufferSize,

								UINT32 *pdwResponseMessageID,
								void  *pvResponseBuffer,
								UINT32 *cbResponseBufferSize,

								void *pvUserContext,
								void *pvReserved );

void DnDAgent_EventHandler(			L5_CONNECTION Conn,
									 L5_EVENT eEvent,
									 void *pvEventData,
									 void *pvUserContext );

#endif //_DND_AGENT_H_
